import React, { Component } from 'react';
import { FlipperProps, InProgressAnimations, FlipCallbacks } from 'flip-toolkit/dist/types';
import { FlippedElementPositionsBeforeUpdateReturnVals } from 'flip-toolkit/dist/flip/getFlippedElementPositions/getFlippedElementPositionsBeforeUpdate/types';
import { SetIsGestureInitiated } from 'flip-toolkit/dist/Swipe/types';
export interface GestureContextProps {
    inProgressAnimations: InProgressAnimations;
    setIsGestureInitiated: SetIsGestureInitiated;
}
export declare const FlipContext: React.Context<FlipCallbacks>;
export declare const PortalContext: React.Context<string>;
export declare const GestureContext: React.Context<GestureContextProps>;
declare class Flipper extends Component<FlipperProps> {
    static defaultProps: {
        applyTransformOrigin: boolean;
        element: string;
    };
    private isGestureControlled;
    private isGestureInitiated;
    private inProgressAnimations;
    private flipCallbacks;
    private el?;
    setIsGestureInitiated: () => void;
    componentDidMount(): void;
    getSnapshotBeforeUpdate(prevProps: FlipperProps): FlippedElementPositionsBeforeUpdateReturnVals | null;
    componentDidUpdate(prevProps: FlipperProps, _prevState: any, cachedData: FlippedElementPositionsBeforeUpdateReturnVals): void;
    render(): JSX.Element;
}
export default Flipper;
